iPokeMon (iOS Client: [Master](https://itunes.apple.com/app/id601694902))
=====================

# Description

### About Project

iPokeMon is a project that try to implement the PokéMon game on iOS with Location Based Service.

This was my Graduation Project. I tried to submit it to the App Store when the v0.3.2 done, but finally, the binary was rejected on May 16, 2012 with the reason of rejection: "8.5: Use of protected 3rd party material (trademarks, copyrights, trade secrets, otherwise proprietary content) requires a documented rights check which must be provided upon request". What a pity! There was a time I wanted to ask some designers to create a set of PokéMon like characters, but I gave up the thought cause it'll lose its meaning then. So after I graduated from university on Jun, 2012, I shelved this project for several months.  

Till now, I still hope to have such a game on iOS. With my own limited capacity, iPokeMon is still in beta version. So I open source this whole project in order to let more and more people (both programmer & designer, or even just a player are all welcomed) participate in the development. I look forward to that one day it can be owned by everyone that grown up with PokéMon!

Finally, I would like to say that feel free to transplant this project to any system! And I'll be glad if you send me a mail about your transplanting. ;)

You can follow me for updates on the development: [Twitter](http://twitter.com/kJulYu) / [Sina Weibo](http://weibo.com/kjuly).

### About App: Master

Master is the iOS client of iPokeMon project. It is an extensible game template of RPG with Location Based Service. 

Characters in game are distributed in the real world. You'll find & catch different characters in different cities, or even countries. 

The game template allows you to load the third-party resources (e.g. PokéMon related resource) to define your own characters, including the name, appearance, etc. Make any classic game resources as you can, and don't forget to share it with your friends!

[__SERVER SIDE SOURCE CODE__](https://github.com/Kjuly/iPokeMon-Server).

<p align="center" >
  <a href="https://itunes.apple.com/app/id601694902" target="_blank">
  <img src="https://raw.github.com/Kjuly/KYProjectPageTheme/master/stylesheets/images/download.png" alt="Download on the App Store" title="Download on the App Store">
  </a>
</p>

---
# Game Play Demo

- [Youtube](http://www.youtube.com/watch?v=otiBQnwdt0U) - 2012-05-09
- [Youku](http://v.youku.com/v_show/id_XNDA1MjExMDg4.html) - 2012-06-03 (Newer)

Refer to the [__Game Play Manual__](https://github.com/Kjuly/iPokeMon/wiki/Game-Play).

---
# [Change Log](https://github.com/Kjuly/iPokeMon/wiki/Change-Log)

Change log is located in Wiki: [Change Log](https://github.com/Kjuly/iPokeMon/wiki/Change-Log). It also includes a TODO list, which shows further plans. If you've any idea about this project, just speak it out and you may receive a special gift from the iPokeMon world! Looking forward to your great idea! ;)

---
# Dependence

- [AFNetworking](https://github.com/AFNetworking/AFNetworking)
- [Cocos2D-iPhone](https://github.com/cocos2d/cocos2d-iphone)
- [GTMOAuth2](http://code.google.com/p/gtm-oauth2/)
- [JSONKit](https://github.com/johnezang/JSONKit)
- [KYArcTab](https://github.com/Kjuly/KYArcTab)
- [KYCircleMenu](https://github.com/Kjuly/KYCircleMenu)
- [MBProgressHUD](https://github.com/jdg/MBProgressHUD)

Master requires iOS 5.0 SDK or later.

---
# Apply for Beta Version Testing

The Beta version of Master is hosted on TestFlight, just register a account and join [__MY TEAM__](https://testflightapp.com/join/e06876e16b88d3f657280efa073d2b64-NzQ0NzM/).  
Or you can join other developers' teams [__HERE__](https://github.com/Kjuly/iPokeMon/wiki/Tester-Recruitment).

---
# Make Contributions

### Project Improvement

If you have some spare time then there is no better way to help an open source project than to get involved at one level or another. Contributions are very much appreciated and needed in any of the following ways:

  - Improve the source code;
  - Help diagnose and report problems;
  - Suggest fixes by sending in patches;
  - Help with unit and end-to-end testing;
  - Provide peer support on our forum or on the Sencha forum;
  - Publish an article on your blog (send the link) to educate others regarding some aspect of the project;
  - Help with missing documentation;
  - Improve the game data.

For programmers, if you want to be a contributor of the source code, just fork this repo as your own and improve the code in your own repo. When you done, send a "Pull Request" to me. I'll merge the commits after checking. And b.t.w, it is better to send "Pull Request" whenever you've modify the source code, even a modification of one word. :) \[[__Configuration Page__](https://github.com/Kjuly/iPokeMon/wiki/Configuration)\]

And for designers, feel free to discuss with me on the design work via email: `kj#kjuly.com`.

I collected the original data of iPokeMon on the internet. Most of them are okay, but of course, the lack is also hard to avoid. So I'm glad that you can help me to improve the data.

### Monetary Support

As an independent developer, I need some support with microdonations to continue the project. Your monetary support is greatly appreciated!

<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=dev@kjuly.com&lc=US&item_name=iPokeMon_Project_Donation&no_note=1&currency_code=USD">
<img src="https://www.paypalobjects.com/en_US/i/btn/btn_donate_SM.gif"/>
</a>
<a href="http://me.alipay.com/kjuly" target="_blank">
<img src="https://github.com/Kjuly/iPokeMon/raw/gh-pages/images/donate_with_alipay.png" alt="Donate with Alipay" title="Donate with Alipay" border="0" />
</a>
<a href="http://flattr.com/thing/1100134/" target="_blank">
<img src="http://api.flattr.com/button/flattr-badge-large.png" alt="Flattr this" title="Flattr this" border="0" />
</a>

### Spiritual Encouragement

And an another way to support me, you can purchase any of my iOS Apps which are sold on the [__AppStore__](https://itunes.apple.com/artist/kaijie-yu/id523484108), or just share this page to your friends via _Twitter_, _Facebook_, _Google+_, etc.

Thanks in advance! <3

---
# Feedback

I'd love your feedback.  
Email your comments, suggestions and questions to `dev#kjuly.com`.  
Or you can just post a bug report or a feature request [__HERE__](https://github.com/Kjuly/iPokeMon/issues/new).  
Thank you! :)

---
# License

In addition to the [MIT LICENSE](https://raw.github.com/Kjuly/iPokeMon/dev/LICENSE), I ask that you do not publicly distribute the app as a whole in binary form (e.g. on the App Store). If you do want to, please contact me for the permission first. Thank you! :)

